Index: t3lib/class.t3lib_div.php
===================================================================
--- t3lib/class.t3lib_div.php	(revision 9354)
+++ t3lib/class.t3lib_div.php	(revision )
@@ -3113,41 +3165,57 @@
 	 * @param	string		Content string to write
 	 * @return	string		Returns false on success, otherwise an error string telling about the problem.
 	 */
-	public static function writeFileToTypo3tempDir($filepath,$content)	{
+	public static function writeFileToTypo3tempDir($filepath, $content) {
 
 			// Parse filepath into directory and basename:
 		$fI = pathinfo($filepath);
-		$fI['dirname'].= '/';
+		$fI['dirname'] .= '/';
 
 			// Check parts:
-		if (self::validPathStr($filepath) && $fI['basename'] && strlen($fI['basename'])<60)	{
+		if (self::validPathStr($filepath) && $fI['basename'] && strlen($fI['basename']) < 60) {
-			if (defined('PATH_site'))	{
+			if (defined('PATH_site')) {
-				$dirName = PATH_site.'typo3temp/';	// Setting main temporary directory name (standard)
+				$dirName = PATH_site . 'typo3temp/'; // Setting main temporary directory name (standard)
-				if (@is_dir($dirName))	{
+				if (@is_dir($dirName)) {
-					if (self::isFirstPartOfStr($fI['dirname'],$dirName))	{
+					if (self::isFirstPartOfStr($fI['dirname'], $dirName)) {
 
 							// Checking if the "subdir" is found:
-						$subdir = substr($fI['dirname'],strlen($dirName));
+						$subdir = substr($fI['dirname'], strlen($dirName));
-						if ($subdir)	{
+						if ($subdir) {
-							if (preg_match('/^[[:alnum:]_]+\/$/',$subdir) || preg_match('/^[[:alnum:]_]+\/[[:alnum:]_]+\/$/',$subdir))	{
+							if (preg_match('/^[[:alnum:]_]+\/$/', $subdir) || preg_match('/^[[:alnum:]_]+\/[[:alnum:]_]+\/$/', $subdir)) {
-								$dirName.= $subdir;
+								$dirName .= $subdir;
-								if (!@is_dir($dirName))	{
+								if (!@is_dir($dirName)) {
-									self::mkdir_deep(PATH_site.'typo3temp/', $subdir);
+									self::mkdir_deep(PATH_site . 'typo3temp/', $subdir);
 								}
-							} else return 'Subdir, "'.$subdir.'", was NOT on the form "[[:alnum:]_]/" or  "[[:alnum:]_]/[[:alnum:]_]/"';
+							} else {
+								return 'Subdir, "' . $subdir . '", was NOT on the form "[[:alnum:]_]/" or  "[[:alnum:]_]/[[:alnum:]_]/"';
-						}
+							}
+						}
 							// Checking dir-name again (sub-dir might have been created):
-						if (@is_dir($dirName))	{
+						if (@is_dir($dirName)) {
-							if ($filepath == $dirName.$fI['basename'])	{
+							if ($filepath == $dirName . $fI['basename']) {
 								self::writeFile($filepath, $content);
-								if (!@is_file($filepath))	return 'File not written to disk! Write permission error in filesystem?';
-							} else return 'Calculated filelocation didn\'t match input $filepath!';
-						} else return '"'.$dirName.'" is not a directory!';
-					} else return '"'.$fI['dirname'].'" was not within directory PATH_site + "typo3temp/"';
-				} else return 'PATH_site + "typo3temp/" was not a directory!';
-			} else return 'PATH_site constant was NOT defined!';
-		} else return 'Input filepath "'.$filepath.'" was generally invalid!';
+								if (!@is_file($filepath)) {
+									return 'File not written to disk! Write permission error in filesystem?';
-	}
+								}
+							} else {
+								return 'Calculated filelocation didn\'t match input $filepath!';
+							}
+						} else {
+							return '"' . $dirName . '" is not a directory!';
+						}
+					} else {
+						return '"' . $fI['dirname'] . '" was not within directory PATH_site + "typo3temp/"';
+					}
+				} else {
+					return 'PATH_site + "typo3temp/" was not a directory!';
+				}
+			} else {
+				return 'PATH_site constant was NOT defined!';
+			}
+		} else {
+			return 'Input filepath "' . $filepath . '" was generally invalid!';
+		}
+	}
 
 	/**
 	 * Wrapper function for mkdir.
@@ -3173,15 +3241,15 @@
 	 * @param	string		Deep directory to create, eg. "xx/yy/" which creates "/root/typo3site/xx/yy/" if $destination is "/root/typo3site/"
 	 * @return	string		If error, returns error string.
 	 */
-	public static function mkdir_deep($destination,$deepDir)	{
+	public static function mkdir_deep($destination, $deepDir) {
-		$allParts = self::trimExplode('/',$deepDir,1);
+		$allParts = self::trimExplode('/', $deepDir, 1);
 		$root = '';
-		foreach($allParts as $part)	{
+		foreach ($allParts as $part) {
-			$root.= $part.'/';
+			$root .= $part . '/';
-			if (!is_dir($destination.$root))	{
+			if (!is_dir($destination . $root)) {
-				self::mkdir($destination.$root);
+				self::mkdir($destination . $root);
-				if (!@is_dir($destination.$root))	{
+				if (!@is_dir($destination . $root)) {
-					return 'Error: The directory "'.$destination.$root.'" could not be created...';
+					return 'Error: The directory "' . $destination . $root . '" could not be created...';
 				}
 			}
 		}
@@ -3194,24 +3262,28 @@
 	 * @param	boolean		Allow deletion of non-empty directories
 	 * @return	boolean		true if @rmdir went well!
 	 */
-	public static function rmdir($path,$removeNonEmpty=false)	{
-		$OK = false;
+	public static function rmdir($path, $removeNonEmpty = FALSE) {
+		$OK = FALSE;
-		$path = preg_replace('|/$|','',$path);	// Remove trailing slash
+		$path = preg_replace('|/$|', '', $path); // Remove trailing slash
 
-		if (file_exists($path))	{
+		if (file_exists($path)) {
-			$OK = true;
+			$OK = TRUE;
 
-			if (is_dir($path))	{
+			if (is_dir($path)) {
-				if ($removeNonEmpty==true && $handle = opendir($path))	{
-					while ($OK && false !== ($file = readdir($handle)))	{
-						if ($file=='.' || $file=='..') continue;
+				if ($removeNonEmpty == TRUE && $handle = opendir($path)) {
+					while ($OK && FALSE !== ($file = readdir($handle))) {
+						if ($file == '.' || $file == '..') {
+							continue;
+						}
-						$OK = self::rmdir($path.'/'.$file,$removeNonEmpty);
+						$OK = self::rmdir($path . '/' . $file, $removeNonEmpty);
 					}
 					closedir($handle);
 				}
-				if ($OK)	{ $OK = rmdir($path); }
+				if ($OK) {
+					$OK = rmdir($path);
+				}
 
-			} else {	// If $dirname is a file, simply remove it
+			} else { // If $dirname is a file, simply remove it
 				$OK = unlink($path);
 			}
 
@@ -3229,7 +3301,7 @@
 	 * @param	string		Path to list directories from
 	 * @return	array		Returns an array with the directory entries as values. If no path, the return value is nothing.
 	 */
-	public static function get_dirs($path)	{
+	public static function get_dirs($path) {
 		if ($path) {
 			if (is_dir($path)) {
 				$dir = scandir($path);
@@ -3257,7 +3329,7 @@
 	 * @param	string		A comma seperated list of filenames to exclude, no wildcards
 	 * @return	array		Array of the files found
 	 */
-	public static function getFilesInDir($path,$extensionList='',$prependPath=0,$order='',$excludePattern='')	{
+	public static function getFilesInDir($path, $extensionList = '', $prependPath = 0, $order = '', $excludePattern = '') {
 
 			// Initialize variabels:
 		$filearray = array();
@@ -3265,33 +3337,39 @@
 		$path = rtrim($path, '/');
 
 			// Find files+directories:
-		if (@is_dir($path))	{
+		if (@is_dir($path)) {
 			$extensionList = strtolower($extensionList);
 			$d = dir($path);
-			if (is_object($d))	{
+			if (is_object($d)) {
-				while($entry=$d->read()) {
+				while ($entry = $d->read()) {
-					if (@is_file($path.'/'.$entry))	{
+					if (@is_file($path . '/' . $entry)) {
 						$fI = pathinfo($entry);
-						$key = md5($path.'/'.$entry);	// Don't change this ever - extensions may depend on the fact that the hash is an md5 of the path! (import/export extension)
+						$key = md5($path . '/' . $entry); // Don't change this ever - extensions may depend on the fact that the hash is an md5 of the path! (import/export extension)
-						if ((!strlen($extensionList) || self::inList($extensionList,strtolower($fI['extension']))) && (!strlen($excludePattern) || !preg_match('/^'.$excludePattern.'$/',$entry)))	{
+						if ((!strlen($extensionList) || self::inList($extensionList, strtolower($fI['extension']))) && (!strlen($excludePattern) || !preg_match('/^' . $excludePattern . '$/', $entry))) {
-							$filearray[$key]=($prependPath?$path.'/':'').$entry;
+							$filearray[$key] = ($prependPath ? $path . '/' : '') . $entry;
-								if ($order=='mtime') {$sortarray[$key]=filemtime($path.'/'.$entry);}
-								elseif ($order)	{$sortarray[$key]=$entry;}
+							if ($order == 'mtime') {
+								$sortarray[$key] = filemtime($path . '/' . $entry);
-						}
+							}
+							elseif ($order) {
+								$sortarray[$key] = $entry;
-					}
-				}
+							}
+						}
+					}
+				}
 				$d->close();
-			} else return 'error opening path: "'.$path.'"';
+			} else {
+				return 'error opening path: "' . $path . '"';
-		}
+			}
+		}
 
 			// Sort them:
 		if ($order) {
 			asort($sortarray);
-			$newArr=array();
+			$newArr = array();
 			foreach ($sortarray as $k => $v) {
-				$newArr[$k]=$filearray[$k];
+				$newArr[$k] = $filearray[$k];
 			}
-			$filearray=$newArr;
+			$filearray = $newArr;
 		}
 
 			// Return result
@@ -3311,15 +3389,17 @@
 	 * @param string		$excludePattern: regex pattern of files/directories to exclude
 	 * @return	array		An array with the found files/directories.
 	 */
-	public static function getAllFilesAndFoldersInPath(array $fileArr,$path,$extList='',$regDirs=0,$recursivityLevels=99,$excludePattern='')	{
+	public static function getAllFilesAndFoldersInPath(array $fileArr, $path, $extList = '', $regDirs = 0, $recursivityLevels = 99, $excludePattern = '') {
-		if ($regDirs)	$fileArr[] = $path;
+		if ($regDirs) {
+			$fileArr[] = $path;
+		}
-		$fileArr = array_merge($fileArr, self::getFilesInDir($path,$extList,1,1,$excludePattern));
+		$fileArr = array_merge($fileArr, self::getFilesInDir($path, $extList, 1, 1, $excludePattern));
 
 		$dirs = self::get_dirs($path);
-		if (is_array($dirs) && $recursivityLevels>0)	{
+		if (is_array($dirs) && $recursivityLevels > 0) {
-			foreach ($dirs as $subdirs)	{
+			foreach ($dirs as $subdirs) {
-				if ((string)$subdirs!='' && (!strlen($excludePattern) || !preg_match('/^'.$excludePattern.'$/',$subdirs)))	{
+				if ((string) $subdirs != '' && (!strlen($excludePattern) || !preg_match('/^' . $excludePattern . '$/', $subdirs))) {
-					$fileArr = self::getAllFilesAndFoldersInPath($fileArr,$path.$subdirs.'/',$extList,$regDirs,$recursivityLevels-1,$excludePattern);
+					$fileArr = self::getAllFilesAndFoldersInPath($fileArr, $path . $subdirs . '/', $extList, $regDirs, $recursivityLevels - 1, $excludePattern);
 				}
 			}
 		}
@@ -3334,7 +3414,7 @@
 	 * @param	string		$prefixToRemove: The prefix path to remove (if found as first part of string!)
 	 * @return	array		The input $fileArr processed.
 	 */
-	public static function removePrefixPathFromList(array $fileArr,$prefixToRemove)	{
+	public static function removePrefixPathFromList(array $fileArr, $prefixToRemove) {
 		foreach ($fileArr as $k => &$absFileRef) {
 			if (self::isFirstPartOfStr($absFileRef, $prefixToRemove)) {
 				$absFileRef = substr($absFileRef, strlen($prefixToRemove));
@@ -3352,8 +3432,8 @@
 	 * @param	string		File path to process
 	 * @return	string
 	 */
-	public static function fixWindowsFilePath($theFile)	{
+	public static function fixWindowsFilePath($theFile) {
-		return str_replace('//','/', str_replace('\\','/', $theFile));
+		return str_replace('//', '/', str_replace('\\', '/', $theFile));
 	}
 
 	/**
@@ -3364,22 +3444,24 @@
 	 * @param	string		File path in which "/../" is resolved
 	 * @return	string
 	 */
-	public static function resolveBackPath($pathStr)	{
+	public static function resolveBackPath($pathStr) {
-		$parts = explode('/',$pathStr);
+		$parts = explode('/', $pathStr);
-		$output=array();
+		$output = array();
 		$c = 0;
-		foreach($parts as $pV)	{
+		foreach ($parts as $pV) {
-			if ($pV=='..')	{
+			if ($pV == '..') {
-				if ($c)	{
+				if ($c) {
 					array_pop($output);
 					$c--;
-				} else $output[]=$pV;
-			} else {
+				} else {
+					$output[] = $pV;
+				}
+			} else {
 				$c++;
-				$output[]=$pV;
+				$output[] = $pV;
 			}
 		}
-		return implode('/',$output);
+		return implode('/', $output);
 	}
 
 	/**
@@ -3392,12 +3474,12 @@
 	 * @param	string		URL / path to prepend full URL addressing to.
 	 * @return	string
 	 */
-	public static function locationHeaderUrl($path)	{
+	public static function locationHeaderUrl($path) {
 		$uI = parse_url($path);
-		if (substr($path,0,1)=='/')	{ // relative to HOST
+		if (substr($path, 0, 1) == '/') { // relative to HOST
-			$path = self::getIndpEnv('TYPO3_REQUEST_HOST').$path;
+			$path = self::getIndpEnv('TYPO3_REQUEST_HOST') . $path;
-		} elseif (!$uI['scheme'])	{ // No scheme either
+		} elseif (!$uI['scheme']) { // No scheme either
-			$path = self::getIndpEnv('TYPO3_REQUEST_DIR').$path;
+			$path = self::getIndpEnv('TYPO3_REQUEST_DIR') . $path;
 		}
 		return $path;
 	}
@@ -3439,13 +3521,17 @@
 	public static function getBytesFromSizeMeasurement($measurement) {
 		if (stripos($measurement, 'G')) {
 			$bytes = doubleval($measurement) * 1024 * 1024 * 1024;
-		} else if (stripos($measurement, 'M')) {
+		} else {
+			if (stripos($measurement, 'M')) {
-			$bytes = doubleval($measurement) * 1024 * 1024;
+				$bytes = doubleval($measurement) * 1024 * 1024;
-		} else if (stripos($measurement, 'K')) {
+			} else {
+				if (stripos($measurement, 'K')) {
-			$bytes = doubleval($measurement) * 1024;
-		} else {
-			$bytes = doubleval($measurement);
-		}
+					$bytes = doubleval($measurement) * 1024;
+				} else {
+					$bytes = doubleval($measurement);
+				}
+			}
+		}
 		return $bytes;
 	}
 
@@ -3495,57 +3581,54 @@
 	 */
 	public static function createVersionNumberedFilename($file, $forceQueryString = FALSE) {
 		$lookupFile = explode('?', $file);
-		$path = self::resolveBackPath(self::dirname(PATH_thisScript) .'/'. $lookupFile[0]);
+		$path = self::resolveBackPath(self::dirname(PATH_thisScript) . '/' . $lookupFile[0]);
 
 		if (TYPO3_MODE == 'FE') {
 			$mode = strtolower($GLOBALS['TYPO3_CONF_VARS'][TYPO3_MODE]['versionNumberInFilename']);
 			if ($mode === 'embed') {
 				$mode = TRUE;
-			} else if ($mode === 'querystring') {
+			} else {
+				if ($mode === 'querystring') {
-				$mode = FALSE;
-			} else {
-				$doNothing = TRUE;
-			}
+					$mode = FALSE;
+				} else {
+					$doNothing = TRUE;
+				}
+			}
 		} else {
 			$mode = $GLOBALS['TYPO3_CONF_VARS'][TYPO3_MODE]['versionNumberInFilename'];
 		}
 
-		if (! file_exists($path) || $doNothing) {
+		if (!file_exists($path) || $doNothing) {
 				// File not found, return filename unaltered
 			$fullName = $file;
 
-		} else if (! $mode || $forceQueryString) {
+		} else {
+			if (!$mode || $forceQueryString) {
-				// If use of .htaccess rule is not configured,
-				// we use the default query-string method
-			if ($lookupFile[1]) {
-				$separator = '&';
-			} else {
-				$separator = '?';
-			}
-			$fullName = $file . $separator . filemtime($path);
+					// If use of .htaccess rule is not configured,
+					// we use the default query-string method
+				if ($lookupFile[1]) {
+					$separator = '&';
+				} else {
+					$separator = '?';
+				}
+				$fullName = $file . $separator . filemtime($path);
 
-		} else {
-				// Change the filename
-			$name = explode('.', $lookupFile[0]);
-			$extension = array_pop($name);
+			} else {
+					// Change the filename
+				$name = explode('.', $lookupFile[0]);
+				$extension = array_pop($name);
 
-			array_push($name, filemtime($path), $extension);
-			$fullName = implode('.', $name);
-				// append potential query string
-			$fullName .= $lookupFile[1] ? '?' . $lookupFile[1] : '';
-		}
+				array_push($name, filemtime($path), $extension);
+				$fullName = implode('.', $name);
+					// append potential query string
+				$fullName .= $lookupFile[1] ? '?' . $lookupFile[1] : '';
+			}
+		}
 
 		return $fullName;
 	}
 
 
-
-
-
-
-
-
-
 	/*************************
 	 *
 	 * DEBUG helper FUNCTIONS
@@ -3560,10 +3643,12 @@
 	 * @param	integer		Number of characters to show
 	 * @return	string		The string with ASCII values in separated by a space char.
 	 */
-	public static function debug_ordvalue($string,$characters=100)	{
+	public static function debug_ordvalue($string, $characters = 100) {
-		if(strlen($string) < $characters)	$characters = strlen($string);
+		if (strlen($string) < $characters) {
+			$characters = strlen($string);
+		}
-		for ($i=0; $i<$characters; $i++)	{
+		for ($i = 0; $i < $characters; $i++) {
-			$valuestring.=' '.ord(substr($string,$i,1));
+			$valuestring .= ' ' . ord(substr($string, $i, 1));
 		}
 		return trim($valuestring);
 	}
@@ -3577,19 +3662,19 @@
 	 * @param	mixed		Array to view
 	 * @return	string		HTML output
 	 */
-	public static function view_array($array_in)	{
+	public static function view_array($array_in) {
-		if (is_array($array_in))	{
+		if (is_array($array_in)) {
-			$result='
+			$result = '
 			<table border="1" cellpadding="1" cellspacing="0" bgcolor="white">';
-			if (count($array_in) == 0)	{
+			if (count($array_in) == 0) {
-				$result.= '<tr><td><font face="Verdana,Arial" size="1"><strong>EMPTY!</strong></font></td></tr>';
+				$result .= '<tr><td><font face="Verdana,Arial" size="1"><strong>EMPTY!</strong></font></td></tr>';
-			} else	{
+			} else {
-				foreach ($array_in as $key => $val)	{
+				foreach ($array_in as $key => $val) {
-					$result.= '<tr>
+					$result .= '<tr>
-						<td valign="top"><font face="Verdana,Arial" size="1">'.htmlspecialchars((string)$key).'</font></td>
+						<td valign="top"><font face="Verdana,Arial" size="1">' . htmlspecialchars((string) $key) . '</font></td>
 						<td>';
-					if (is_array($val))	{
+					if (is_array($val)) {
-						$result.=self::view_array($val);
+						$result .= self::view_array($val);
 					} elseif (is_object($val)) {
 						$string = '';
 						if (method_exists($val, '__toString')) {
@@ -3597,26 +3682,26 @@
 						} else {
 							$string .= print_r($val, TRUE);
 						}
-						$result .= '<font face="Verdana,Arial" size="1" color="red">'.nl2br(htmlspecialchars($string)).'<br /></font>';
+						$result .= '<font face="Verdana,Arial" size="1" color="red">' . nl2br(htmlspecialchars($string)) . '<br /></font>';
-					} else	{
+					} else {
-						if (gettype($val) == 'object')	{
+						if (gettype($val) == 'object') {
 							$string = 'Unknown object';
-						} else	{
+						} else {
-							$string = (string)$val;
+							$string = (string) $val;
 						}
-						$result.= '<font face="Verdana,Arial" size="1" color="red">'.nl2br(htmlspecialchars($string)).'<br /></font>';
+						$result .= '<font face="Verdana,Arial" size="1" color="red">' . nl2br(htmlspecialchars($string)) . '<br /></font>';
 					}
-					$result.= '</td>
+					$result .= '</td>
 					</tr>';
 				}
 			}
-			$result.= '</table>';
+			$result .= '</table>';
 		} else {
-			$result  = '<table border="1" cellpadding="1" cellspacing="0" bgcolor="white">
+			$result = '<table border="1" cellpadding="1" cellspacing="0" bgcolor="white">
 				<tr>
-					<td><font face="Verdana,Arial" size="1" color="red">'.nl2br(htmlspecialchars((string)$array_in)).'<br /></font></td>
+					<td><font face="Verdana,Arial" size="1" color="red">' . nl2br(htmlspecialchars((string) $array_in)) . '<br /></font></td>
 				</tr>
-			</table>';	// Output it as a string.
+			</table>'; // Output it as a string.
 		}
 		return $result;
 	}
@@ -3629,7 +3714,7 @@
 	 * @return	void
 	 * @see view_array()
 	 */
-	public static function print_array($array_in)	{
+	public static function print_array($array_in) {
 		echo self::view_array($array_in);
 	}
 
@@ -3645,9 +3730,9 @@
 	 * @param	string		Group for the debug console
 	 * @return	void
 	 */
-	public static function debug($var = '', $header = '', $group = 'Debug')	{
+	public static function debug($var = '', $header = '', $group = 'Debug') {
 			// buffer the output of debug if no buffering started before
-		if (ob_get_level()==0) {
+		if (ob_get_level() == 0) {
 			ob_start();
 		}
 		$debug = '';
@@ -3657,27 +3742,27 @@
 			<table class="typo3-debug" border="0" cellpadding="0" cellspacing="0" bgcolor="white" style="border:0px; margin-top:3px; margin-bottom:3px;">
 				<tr>
 					<td style="background-color:#bbbbbb; font-family: verdana,arial; font-weight: bold; font-size: 10px;">' .
-						htmlspecialchars((string) $header) .
+					htmlspecialchars((string) $header) .
 					'</td>
 				</tr>
 				<tr>
 					<td>';
 		}
 
-		if (is_array($var))	{
+		if (is_array($var)) {
 			$debug .= self::view_array($var);
 		} elseif (is_object($var)) {
-			$debug .=  '<strong>|Object:<pre>';
+			$debug .= '<strong>|Object:<pre>';
 			$debug .= print_r($var, TRUE);
-			$debug .=  '</pre>|</strong>';
+			$debug .= '</pre>|</strong>';
-		} elseif ((string) $var !== '')	{
+		} elseif ((string) $var !== '') {
-			$debug .= '<strong>|' . htmlspecialchars((string)$var) . '|</strong>';
+			$debug .= '<strong>|' . htmlspecialchars((string) $var) . '|</strong>';
 		} else {
 			$debug .= '<strong>| debug |</strong>';
 		}
 
 		if ($header) {
-			$debug .=  '
+			$debug .= '
 					</td>
 				</tr>
 			</table>';
@@ -3749,17 +3834,17 @@
 	 *
 	 * @return	string
 	 */
-	public static function debug_trail()	{
+	public static function debug_trail() {
 		$trail = debug_backtrace();
 		$trail = array_reverse($trail);
 		array_pop($trail);
 
 		$path = array();
-		foreach($trail as $dat)	{
+		foreach ($trail as $dat) {
-			$path[] = $dat['class'].$dat['type'].$dat['function'].'#'.$dat['line'];
+			$path[] = $dat['class'] . $dat['type'] . $dat['function'] . '#' . $dat['line'];
 		}
 
-		return implode(' // ',$path);
+		return implode(' // ', $path);
 	}
 
 	/**
@@ -3770,74 +3855,54 @@
 	 * @param	boolean		If TRUE, will return content instead of echo'ing out.
 	 * @return	void		Outputs to browser.
 	 */
-	public static function debugRows($rows,$header='',$returnHTML=FALSE)	{
+	public static function debugRows($rows, $header = '', $returnHTML = FALSE) {
-		if (is_array($rows))	{
+		if (is_array($rows)) {
 			reset($rows);
 			$firstEl = current($rows);
-			if (is_array($firstEl))	{
+			if (is_array($firstEl)) {
 				$headerColumns = array_keys($firstEl);
 				$tRows = array();
 
 					// Header:
-				$tRows[] = '<tr><td colspan="'.count($headerColumns).'" style="background-color:#bbbbbb; font-family: verdana,arial; font-weight: bold; font-size: 10px;"><strong>'.htmlspecialchars($header).'</strong></td></tr>';
+				$tRows[] = '<tr><td colspan="' . count($headerColumns) . '" style="background-color:#bbbbbb; font-family: verdana,arial; font-weight: bold; font-size: 10px;"><strong>' . htmlspecialchars($header) . '</strong></td></tr>';
 				$tCells = array();
-				foreach($headerColumns as $key)	{
+				foreach ($headerColumns as $key) {
 					$tCells[] = '
-							<td><font face="Verdana,Arial" size="1"><strong>'.htmlspecialchars($key).'</strong></font></td>';
+							<td><font face="Verdana,Arial" size="1"><strong>' . htmlspecialchars($key) . '</strong></font></td>';
 				}
 				$tRows[] = '
-						<tr>'.implode('',$tCells).'
+						<tr>' . implode('', $tCells) . '
 						</tr>';
 
 					// Rows:
-				foreach($rows as $singleRow)	{
+				foreach ($rows as $singleRow) {
 					$tCells = array();
-					foreach($headerColumns as $key)	{
+					foreach ($headerColumns as $key) {
 						$tCells[] = '
-							<td><font face="Verdana,Arial" size="1">'.(is_array($singleRow[$key]) ? self::debugRows($singleRow[$key],'',TRUE) : htmlspecialchars($singleRow[$key])).'</font></td>';
+							<td><font face="Verdana,Arial" size="1">' . (is_array($singleRow[$key]) ? self::debugRows($singleRow[$key], '', TRUE) : htmlspecialchars($singleRow[$key])) . '</font></td>';
 					}
 					$tRows[] = '
-						<tr>'.implode('',$tCells).'
+						<tr>' . implode('', $tCells) . '
 						</tr>';
 				}
 
 				$table = '
-					<table border="1" cellpadding="1" cellspacing="0" bgcolor="white">'.implode('',$tRows).'
+					<table border="1" cellpadding="1" cellspacing="0" bgcolor="white">' . implode('', $tRows) . '
 					</table>';
-				if ($returnHTML)	return $table; else echo $table;
-			} else debug('Empty array of rows',$header);
+				if ($returnHTML) {
+					return $table;
-		} else {
+				} else {
+					echo $table;
+				}
+			} else {
+				debug('Empty array of rows', $header);
+			}
+		} else {
-			debug('No array of rows',$header);
+			debug('No array of rows', $header);
 		}
 	}
 
 
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
 	/*************************
 	 *
 	 * SYSTEM INFORMATION
@@ -3850,10 +3915,10 @@
 	 *
 	 * @return	string
 	 */
-	public static function getThisUrl()	{
+	public static function getThisUrl() {
-		$p=parse_url(self::getIndpEnv('TYPO3_REQUEST_SCRIPT'));		// Url of this script
+		$p = parse_url(self::getIndpEnv('TYPO3_REQUEST_SCRIPT')); // Url of this script
-		$dir=self::dirname($p['path']).'/';	// Strip file
+		$dir = self::dirname($p['path']) . '/'; // Strip file
-		$url = str_replace('//','/',$p['host'].($p['port']?':'.$p['port']:'').$dir);
+		$url = str_replace('//', '/', $p['host'] . ($p['port'] ? ':' . $p['port'] : '') . $dir);
 		return $url;
 	}
 
@@ -3892,17 +3957,17 @@
 	 * @param	array		Array of key/value pairs for get parameters to add/overrule with. Can be multidimensional.
 	 * @return	string		Output URL with added getParams.
 	 */
-	public static function linkThisUrl($url,array $getParams=array())	{
+	public static function linkThisUrl($url, array $getParams = array()) {
 		$parts = parse_url($url);
 		$getP = array();
-		if ($parts['query'])	{
+		if ($parts['query']) {
-			parse_str($parts['query'],$getP);
+			parse_str($parts['query'], $getP);
 		}
-		$getP = self::array_merge_recursive_overrule($getP,$getParams);
+		$getP = self::array_merge_recursive_overrule($getP, $getParams);
-		$uP = explode('?',$url);
+		$uP = explode('?', $url);
 
-		$params = self::implodeArrayForUrl('',$getP);
+		$params = self::implodeArrayForUrl('', $getP);
-		$outurl = $uP[0].($params ? '?'.substr($params, 1) : '');
+		$outurl = $uP[0] . ($params ? '?' . substr($params, 1) : '');
 
 		return $outurl;
 	}
@@ -3915,7 +3980,7 @@
 	 * @param	string		Name of the "environment variable"/"server variable" you wish to use. Valid values are SCRIPT_NAME, SCRIPT_FILENAME, REQUEST_URI, PATH_INFO, REMOTE_ADDR, REMOTE_HOST, HTTP_REFERER, HTTP_HOST, HTTP_USER_AGENT, HTTP_ACCEPT_LANGUAGE, QUERY_STRING, TYPO3_DOCUMENT_ROOT, TYPO3_HOST_ONLY, TYPO3_HOST_ONLY, TYPO3_REQUEST_HOST, TYPO3_REQUEST_URL, TYPO3_REQUEST_SCRIPT, TYPO3_REQUEST_DIR, TYPO3_SITE_URL, _ARRAY
 	 * @return	string		Value based on the input key, independent of server/os environment.
 	 */
-	public static function getIndpEnv($getEnvName)	{
+	public static function getIndpEnv($getEnvName) {
 		/*
 			Conventions:
 			output from parse_url():
